diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index a12f7f9d2..a0b3b198c 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1151,6 +1144,12 @@ public class Minecraft
         } finally {
             shutdownMinecraftApplet();
         }
+        if (this.hasCrashed) {
+            LOGGER.error("--------------------==========##########==========--------------------");
+            LOGGER.error("                  Better than Adventure has crashed!                  ");
+            LOGGER.error("      Please report this to https://bugs.betterthanadventure.net      ");
+            LOGGER.error("--------------------==========##########==========--------------------");
+        }
     }
 
     public void freeUpMemory() {
@@ -1168,7 +1167,7 @@ public class Minecraft
     }
 
     private void screenshotListener() {
-        if (this.gameSettings.keyScreenshot.isPressed()) {
+        if (GameSettings.KEY_SCREENSHOT.isPressed()) {
             if (!this.isTakingScreenshot) {
                 this.isTakingScreenshot = true;
 
@@ -1256,7 +1255,7 @@ public class Minecraft
         boolean flag = true;
         if (this.objectMouseOver == null) {
             bridge:
-            if (this.gameSettings.easyBridge.value) {
+            if (GameSettings.EASY_BRIDGE.value) {
                 if (clickType == 1) {
                     if (this.thePlayer.xRot < 45) {
                         break bridge;
@@ -1351,7 +1350,7 @@ public class Minecraft
     }
 
     public void resize() {
-        this.resolution.setScale(this.gameSettings.guiScale.value);
+        this.resolution.setScale(GameSettings.GUI_SCALE.value);
         if (this.currentScreen != null) {
             this.currentScreen.opened(this.resolution.getScaledWidthScreenCoords(), this.resolution.getScaledHeightScreenCoords());
         }
@@ -1452,16 +1451,16 @@ public class Minecraft
                         if (this.thePlayer.noPhysics && this.toggleFlyPressed) {
                             final float steps = 20;
 
-                            int step = Math.round(this.gameSettings.flightSpeed.value * steps);
+                            int step = Math.round(GameSettings.FLIGHT_SPEED.value * steps);
                             step += MathHelper.clamp(scrollDelta, -1, 1);
                             float newSpeed = step / steps;
                             newSpeed = MathHelper.clamp(newSpeed, 0.0f, 5.0f);
 
-                            this.gameSettings.flightSpeed.value = newSpeed;
+                            GameSettings.FLIGHT_SPEED.value = newSpeed;
 
                             this.thePlayer.setFlySpeed(newSpeed);
-                            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.flightSpeed);
-                        } else if (!this.gameSettings.keyZoom.isPressed()) {
+                            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.FLIGHT_SPEED);
+                        } else if (!GameSettings.KEY_ZOOM.isPressed()) {
                             this.thePlayer.inventory.changeCurrentSlot(scrollDelta);
                         }
                     }
@@ -1477,14 +1476,14 @@ public class Minecraft
                 }
                 this.thePlayer.input.keyEvent(-1, Mouse.getEventButton(), Mouse.getEventButtonState());
             }
-            if (this.toggleFlyPressed && !this.gameSettings.keyFly.isPressed()) {
+            if (this.toggleFlyPressed && !GameSettings.KEY_FLY.isPressed()) {
                 this.toggleFlyPressed = false;
                 if (this.flyPressedTime + 400 > System.currentTimeMillis()) {
                     this.thePlayer.setNoclip(!this.thePlayer.noPhysics);
                 }
             }
             while (Keyboard.next()) {
-                if (Keyboard.getEventKeyState() && this.gameSettings.showFrameTimes.value && DebugRender.keyPressed(Keyboard.getEventKey())) {
+                if (Keyboard.getEventKeyState() && GameSettings.SHOW_FRAME_TIMES.value && DebugRender.keyPressed(Keyboard.getEventKey())) {
                     continue;
                 }
 
@@ -1497,19 +1496,19 @@ public class Minecraft
                 boolean shift = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
                 //Fix your keyboard Mak you broke the overlay toggle
                 boolean control = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) /* || Keyboard.isKeyDown(Keyboard.KEY_F4)*/;
-                if (!(Keyboard.getEventKeyState() && this.gameSettings.keyToggleDebug.isPressed())) {
+                if (!(Keyboard.getEventKeyState() && GameSettings.KEY_TOGGLE_DEBUG.isPressed())) {
                     this.thePlayer.input.keyEvent(Keyboard.getEventKey(), -1, Keyboard.getEventKeyState());
                 }
 
-                if (this.gameSettings.keyToggleDebug.isPressEvent()) {
+                if (GameSettings.KEY_TOGGLE_DEBUG.isPressEvent()) {
                     this.f3Press = true;
                 }
-                if (this.gameSettings.keyToggleDebug.isReleaseEvent()) {
+                if (GameSettings.KEY_TOGGLE_DEBUG.isReleaseEvent()) {
                     if (this.f3Press) {
                         if (control) {
-                            this.gameSettings.showFrameTimes.toggle();
+                            GameSettings.SHOW_FRAME_TIMES.toggle();
                         } else {
-                            this.gameSettings.showDebugScreen.toggle();
+                            GameSettings.SHOW_DEBUG_SCREEN.toggle();
                         }
 
                         this.f3Press = false;
@@ -1517,32 +1516,32 @@ public class Minecraft
                 }
 
                 if (Keyboard.getEventKeyState()) {
-                    if (this.gameSettings.keyFullScreen.isPressEvent()) {
+                    if (GameSettings.KEY_FULL_SCREEN.isPressEvent()) {
                         this.gameWindow.toggleFullscreen();
                     } else {
-                        if (this.gameSettings.keyToggleDebug.isPressed()) {
+                        if (GameSettings.KEY_TOGGLE_DEBUG.isPressed()) {
                             if (Keyboard.getEventKey() == Keyboard.KEY_Q) {
                                 this.hudIngame.addChatMessage(TextFormatting.YELLOW + "Keyboard shortcuts: ");
-                                this.gameSettings.debugsKeys.sort(Comparator.comparing(KeyBinding::getKeyName));
-                                for (KeyBinding binding : this.gameSettings.debugsKeys) {
-                                    this.hudIngame.addChatMessage(String.format("%s + %s: %s", this.gameSettings.keyToggleDebug.getKeyName(), binding.getKeyName(), I18n.getInstance().translateKey(binding.getId())));
+                                GameSettings.DEBUG_KEYS.sort(Comparator.comparing(KeyBinding::getKeyName));
+                                for (KeyBinding binding : GameSettings.DEBUG_KEYS) {
+                                    this.hudIngame.addChatMessage(String.format("%s + %s: %s", GameSettings.KEY_TOGGLE_DEBUG.getKeyName(), binding.getKeyName(), I18n.getInstance().translateKey(binding.getId())));
                                 }
-                                this.hudIngame.addChatMessage(String.format("%s: %s", this.gameSettings.keyToggleTextureAtlas.getKeyName(), I18n.getInstance().translateKey(this.gameSettings.keyToggleTextureAtlas.getId())));
-                                this.hudIngame.addChatMessage(String.format("%s: %s", this.gameSettings.keyReleaseCursor.getKeyName(), I18n.getInstance().translateKey(this.gameSettings.keyReleaseCursor.getId())));
+                                this.hudIngame.addChatMessage(String.format("%s: %s", GameSettings.KEY_TOGGLE_TEXTURE_ATLAS.getKeyName(), I18n.getInstance().translateKey(GameSettings.KEY_TOGGLE_TEXTURE_ATLAS.getId())));
+                                this.hudIngame.addChatMessage(String.format("%s: %s", GameSettings.KEY_RELEASE_CURSOR.getKeyName(), I18n.getInstance().translateKey(GameSettings.KEY_RELEASE_CURSOR.getId())));
                             }
-                            if (this.gameSettings.keyReload.isPressEvent()) {
+                            if (GameSettings.KEY_RELOAD.isPressEvent()) {
                                 forceReload();
-                            } else if (this.gameSettings.keySwitchGamemode.isPressEvent()) {
+                            } else if (GameSettings.KEY_SWITCH_GAMEMODE.isPressEvent()) {
                                 if (this.currentWorld.getLevelData().getCheatsEnabled() || this.currentWorld.isClientSide) {
                                     if (this.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
-                                        this.thePlayer.sendChatMessage("/gamemode 0");
+                                        this.thePlayer.sendChatMessage("/gamemode survival");
                                     } else {
-                                        this.thePlayer.sendChatMessage("/gamemode 1");
+                                        this.thePlayer.sendChatMessage("/gamemode creative");
                                     }
                                 }
-                            } else if (this.gameSettings.keyDumpTextures.isPressEvent()) {
+                            } else if (GameSettings.KEY_DUMP_TEXTURES.isPressEvent()) {
                                 Textures.dumpTextures();
-                            } else if (this.gameSettings.keyFullbright.isPressEvent()) {
+                            } else if (GameSettings.KEY_FULLBRIGHT.isPressEvent()) {
                                 PacketHandlerClient queue = getSendQueue();
 
                                 if (queue != null) {
@@ -1556,43 +1555,43 @@ public class Minecraft
                                     }
                                 }
                                 this.hudIngame.heldItemTooltipElement.setString("Fullbright: " + (this.fullbright ? "On" : "Off"));
-                            } else if (this.gameSettings.keyLightmaps.isPressEvent()) {
-                                if (this.gameSettings.lightmapStyle.value == LightmapStyle.COLORIZED) {
-                                    this.gameSettings.lightmapStyle.value = LightmapStyle.GRAY;
+                            } else if (GameSettings.KEY_LIGHTMAPS.isPressEvent()) {
+                                if (GameSettings.LIGHTMAP_STYLE.value == LightmapStyle.COLORIZED) {
+                                    GameSettings.LIGHTMAP_STYLE.value = LightmapStyle.GRAY;
                                     this.hudIngame.heldItemTooltipElement.setString("Lightmap: Gray");
                                 } else {
-                                    this.gameSettings.lightmapStyle.value = LightmapStyle.COLORIZED;
+                                    GameSettings.LIGHTMAP_STYLE.value = LightmapStyle.COLORIZED;
                                     this.hudIngame.heldItemTooltipElement.setString("Lightmap: Colored");
                                 }
-                            } else if (this.gameSettings.keyCollisionBoxes.isPressEvent()) {
-                                this.gameSettings.showCollisionBoxes.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.showCollisionBoxes);
-                            } else if (this.gameSettings.keyChunkBorders.isPressEvent()) {
-                                this.gameSettings.showChunkBorders.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.showChunkBorders);
-                            } else if (this.gameSettings.keyClearChat.isPressEvent()) {
+                            } else if (GameSettings.KEY_COLLISION_BOXES.isPressEvent()) {
+                                GameSettings.SHOW_COLLISION_BOXES.toggle();
+                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SHOW_COLLISION_BOXES);
+                            } else if (GameSettings.KEY_CHUNK_BORDERS.isPressEvent()) {
+                                GameSettings.SHOW_CHUNK_BORDERS.toggle();
+                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SHOW_CHUNK_BORDERS);
+                            } else if (GameSettings.KEY_CLEAR_CHAT.isPressEvent()) {
                                 this.hudIngame.clearChatMessages();
-                            } else if (this.gameSettings.keyPauseLostFocus.isPressEvent()) {
-                                this.gameSettings.pauseOnLostFocus.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.pauseOnLostFocus);
-                            } else if (this.gameSettings.keyToggleItemInfo.isPressEvent()) {
-                                this.gameSettings.showItemDebugInfo.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.showItemDebugInfo);
-                            } else if (this.gameSettings.keyReloadChunks.isPressEvent()) {
+                            } else if (GameSettings.KEY_PAUSE_LOST_FOCUS.isPressEvent()) {
+                                GameSettings.PAUSE_ON_LOST_FOCUS.toggle();
+                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.PAUSE_ON_LOST_FOCUS);
+                            } else if (GameSettings.KEY_TOGGLE_ITEM_INFO.isPressEvent()) {
+                                GameSettings.SHOW_ITEM_DEBUG_INFO.toggle();
+                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SHOW_ITEM_DEBUG_INFO);
+                            } else if (GameSettings.KEY_RELOAD_CHUNKS.isPressEvent()) {
                                 this.renderGlobal.allChanged();
-                            } else if (this.gameSettings.keySmoothLighting.isPressEvent()) {
-                                this.gameSettings.ambientOcclusion.toggle();
-                                this.gameSettings.ambientOcclusion.onUpdate();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.ambientOcclusion);
+                            } else if (GameSettings.KEY_SMOOTH_LIGHTING.isPressEvent()) {
+                                GameSettings.AMBIENT_OCCLUSION.toggle();
+                                GameSettings.AMBIENT_OCCLUSION.onUpdate();
+                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.AMBIENT_OCCLUSION);
                             }
-                            if (!this.gameSettings.keyToggleDebug.isPressEvent()) this.f3Press = false;
-                        } else if (this.gameSettings.keyReleaseCursor.isPressEvent()) {
+                            if (!GameSettings.KEY_TOGGLE_DEBUG.isPressEvent()) this.f3Press = false;
+                        } else if (GameSettings.KEY_RELEASE_CURSOR.isPressEvent()) {
                             this.mouseInput.releaseCursor();
-                        } else if (this.gameSettings.keyShowConsole.isPressEvent() && this.gameSettings.developerMode.value) {
+                        } else if (GameSettings.KEY_SHOW_CONSOLE.isPressEvent() && GameSettings.DEVELOPER_MODE.value) {
                             displayScreen(new ScreenConsole(this.currentScreen));
                         } else if (Keyboard.getEventKey() == Keyboard.KEY_ESCAPE) {
                             displayInGameMenu();
-                        } else if (this.gameSettings.keyCommand.isPressed()) {
+                        } else if (GameSettings.KEY_COMMAND.isPressed()) {
                             displayScreen(new ScreenChat("/"));
                         } else {
                             checkBoundInputs(InputDevice.keyboard);
@@ -1603,14 +1602,14 @@ public class Minecraft
                 }
             }
 
-            boolean breakBlockPressed = this.gameSettings.keyAttack.isPressed() || (this.controllerInput != null && this.controllerInput.buttonRightTrigger.isPressed());
-            boolean placeBlockPressed = this.gameSettings.keyInteract.isPressed() || (this.controllerInput != null && this.controllerInput.buttonLeftTrigger.isPressed());
+            boolean breakBlockPressed = GameSettings.KEY_ATTACK.isPressed() || (this.controllerInput != null && this.controllerInput.buttonRightTrigger.isPressed());
+            boolean placeBlockPressed = GameSettings.KEY_INTERACT.isPressed() || (this.controllerInput != null && this.controllerInput.buttonLeftTrigger.isPressed());
 
             if (this.currentScreen == null) {
                 if (breakBlockPressed && (float) (this.ticksRan - this.mouseTicksRan) >= this.timer.ticksPerSecond / 5F && this.inGameHasFocus)
-                    clickMouse(0, this.gameSettings.autoHit.value, true);
+                    clickMouse(0, GameSettings.AUTO_HIT.value, true);
                 if (placeBlockPressed && (float) (this.ticksRan - this.mouseTicksRan) >= this.timer.ticksPerSecond / 5F && this.inGameHasFocus)
-                    clickMouse(1, this.gameSettings.autoHit.value, true);
+                    clickMouse(1, GameSettings.AUTO_HIT.value, true);
             }
             mineBlocks(this.currentScreen == null && breakBlockPressed && this.inGameHasFocus);
         }
@@ -1626,9 +1625,9 @@ public class Minecraft
                     this.joinPlayerCounter = 0;
                     this.currentWorld.joinEntityInSurroundings(this.thePlayer);
                 }
-                this.thePlayer.setFlySpeed(this.gameSettings.flightSpeed.value);
-                this.thePlayer.setFlightSmoothness(this.gameSettings.flightSmoothness.value);
-                this.thePlayer.turnWithVehicle = this.gameSettings.turnWithVehicle.value;
+                this.thePlayer.setFlySpeed(GameSettings.FLIGHT_SPEED.value);
+                this.thePlayer.setFlightSmoothness(GameSettings.FLIGHT_SMOOTHNESS.value);
+                this.thePlayer.turnWithVehicle = GameSettings.TURN_WITH_VEHICLE.value;
             }
             if (!this.isGamePaused) {
                 this.worldRenderer.updateRenderer();
@@ -1693,38 +1692,38 @@ public class Minecraft
         boolean control = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
 
         // Attack
-        if (this.gameSettings.keyAttack.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_ATTACK.isPressEvent(currentInputDevice)) {
             clickMouse(0, true, false);
             return true;
         }
 
         // Interact
-        if (this.gameSettings.keyInteract.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_INTERACT.isPressEvent(currentInputDevice)) {
             clickMouse(1, true, false);
             return true;
         }
 
         // Pick block
-        if (this.gameSettings.keyPickBlock.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_PICK_BLOCK.isPressEvent(currentInputDevice)) {
             clickMiddleMouseButton(shift, control);
             return true;
         }
 
         // Toggle overlay
-        if (this.gameSettings.keyToggleOverlay.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_TOGGLE_OVERLAY.isPressEvent(currentInputDevice)) {
             if (control) {
-                this.gameSettings.overlayMode.value++;
-                this.gameSettings.overlayMode.value %= 3;
+                GameSettings.OVERLAY_MODE.value++;
+                GameSettings.OVERLAY_MODE.value %= 3;
             } else {
                 boolean on = false;
-                for (int i = 0; i < this.gameSettings.overlayElements.length; i++) {
-                    if (this.gameSettings.overlayElements[i].value) {
+                for (int i = 0; i < GameSettings.OVERLAY_ELEMENTS.length; i++) {
+                    if (GameSettings.OVERLAY_ELEMENTS[i].value) {
                         on = true;
                         break;
                     }
                 }
-                for (int i = 0; i < this.gameSettings.overlayElements.length; i++) {
-                    this.gameSettings.overlayElements[i].value = !on;
+                for (int i = 0; i < GameSettings.OVERLAY_ELEMENTS.length; i++) {
+                    GameSettings.OVERLAY_ELEMENTS[i].value = !on;
                 }
             }
 
@@ -1732,74 +1731,74 @@ public class Minecraft
         }
 
         // Hide GUI
-        if (this.gameSettings.keyHideGui.isPressEvent(currentInputDevice)) {
-            this.gameSettings.immersiveMode.toggle();
+        if (GameSettings.KEY_HIDE_GUI.isPressEvent(currentInputDevice)) {
+            GameSettings.IMMERSIVE_MODE.toggle();
             return true;
         }
 
         // Switch perspective
-        if (this.gameSettings.keySwitchPerspective.isPressEvent(currentInputDevice)) {
-            this.gameSettings.thirdPersonView.value = (this.gameSettings.thirdPersonView.value + 1) % 3;
+        if (GameSettings.KEY_SWITCH_PERSPECTIVE.isPressEvent(currentInputDevice)) {
+            GameSettings.THIRD_PERSON_VIEW.value = (GameSettings.THIRD_PERSON_VIEW.value + 1) % 3;
             return true;
         }
 
         // Cinematic camera
-        if (this.gameSettings.keyCinematicCamera.isPressEvent(currentInputDevice)) {
-            this.gameSettings.smoothCamera.value = !this.gameSettings.smoothCamera.value;
-            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.smoothCamera);
+        if (GameSettings.KEY_CINEMATIC_CAMERA.isPressEvent(currentInputDevice)) {
+            GameSettings.SMOOTH_CAMERA.value = !GameSettings.SMOOTH_CAMERA.value;
+            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SMOOTH_CAMERA);
             return true;
         }
 
         // Display inventory
-        if (this.gameSettings.keyInventory.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_INVENTORY.isPressEvent(currentInputDevice)) {
             displayScreen(getInventoryScreen());
             return true;
         }
 
         // Display Guidebook
-        if (this.gameSettings.keyGuidebook.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_GUIDEBOOK.isPressEvent(currentInputDevice)) {
             this.thePlayer.displayGuidebookScreen();
             return true;
         }
 
         // Drop item
-        if (this.gameSettings.keyDrop.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_DROP.isPressEvent(currentInputDevice)) {
             this.thePlayer.dropCurrentItem(control);
             return true;
         }
 
         // Enter photo mode
-        if (this.gameSettings.keyPhotoMode.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_PHOTO_MODE.isPressEvent(currentInputDevice)) {
             displayScreen(new ScreenPhotoMode());
             return true;
         }
 
         // Open chat
-        if (this.gameSettings.keyChat.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_CHAT.isPressEvent(currentInputDevice)) {
             displayScreen(new ScreenChat());
             return true;
         }
 
         // Show player list
-        if (isMultiplayerWorld() && this.gameSettings.keyPlayerList.isPressEvent(currentInputDevice)) {
+        if (isMultiplayerWorld() && GameSettings.KEY_PLAYER_LIST.isPressEvent(currentInputDevice)) {
             if (control) {
-                this.gameSettings.playerListPosition.value++;
-                this.gameSettings.playerListPosition.value %= 3;
+                GameSettings.PLAYER_LIST_POSITION.value++;
+                GameSettings.PLAYER_LIST_POSITION.value %= 3;
             } else {
-                this.gameSettings.showPlayerList.value = !this.gameSettings.showPlayerList.value;
+                GameSettings.SHOW_PLAYER_LIST.value = !GameSettings.SHOW_PLAYER_LIST.value;
             }
             return true;
         }
 
         // Fly
-        if (this.thePlayer.getGamemode().hasPlayerFlight() && this.gameSettings.keyFly.isPressEvent(currentInputDevice)) {
+        if (this.thePlayer.getGamemode().hasPlayerFlight() && GameSettings.KEY_FLY.isPressEvent(currentInputDevice)) {
             if (!this.toggleFlyPressed) this.toggleFlyPressed = true;
             this.flyPressedTime = System.currentTimeMillis();
             return true;
         }
 
         // Hotbar switch
-        if (this.gameSettings.keyHotBarSwitch.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_HOT_BAR_SWITCH.isPressEvent(currentInputDevice)) {
             if (!this.thePlayer.inventory.currentSlotLocked()) {
                 if (shift) {
                     this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 27) % (36));
@@ -1814,16 +1813,16 @@ public class Minecraft
         }
 
         // Center view
-        if (this.gameSettings.keyCenterView.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_CENTER_VIEW.isPressEvent(currentInputDevice)) {
             this.thePlayer.xRot = 0.0f;
             return true;
         }
 
         // Lock rotation
-        if (this.gameSettings.keyLockRotation.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_LOCK_ROTATION.isPressEvent(currentInputDevice)) {
             if (control) {
-                this.gameSettings.rotationOverlayMode.value++;
-                this.gameSettings.rotationOverlayMode.value %= 4;
+                GameSettings.ROTATION_OVERLAY_MODE.value++;
+                GameSettings.ROTATION_OVERLAY_MODE.value %= 4;
             } else {
                 if (this.thePlayer.rotationLock == null || this.thePlayer.rotationLock == Direction.NONE) {
                     this.thePlayer.rotationLock = Direction.getDirection(this.thePlayer);
@@ -1840,73 +1839,73 @@ public class Minecraft
         }
 
         // Toggle fog
-        if (this.gameSettings.keyToggleFog.isPressEvent(currentInputDevice)) {
-            int renderDistance = this.gameSettings.renderDistance.value;
+        if (GameSettings.KEY_TOGGLE_FOG.isPressEvent(currentInputDevice)) {
+            int renderDistance = GameSettings.RENDER_DISTANCE.value;
             int nextRenderDistance;
             if (!shift) {
                 nextRenderDistance = renderDistance / 8 * 8 + 8;
             } else {
                 nextRenderDistance = (renderDistance - 1) / 8 * 8;
             }
-            if (nextRenderDistance > this.gameSettings.renderDistance.highest && !shift) {
-                nextRenderDistance = this.gameSettings.renderDistance.highest;
+            if (nextRenderDistance > GameSettings.RENDER_DISTANCE.highest && !shift) {
+                nextRenderDistance = GameSettings.RENDER_DISTANCE.highest;
             }
-            if (nextRenderDistance < this.gameSettings.renderDistance.lowest && shift) {
-                nextRenderDistance = this.gameSettings.renderDistance.lowest;
+            if (nextRenderDistance < GameSettings.RENDER_DISTANCE.lowest && shift) {
+                nextRenderDistance = GameSettings.RENDER_DISTANCE.lowest;
             }
-            if (renderDistance == this.gameSettings.renderDistance.highest && !shift) {
-                nextRenderDistance = this.gameSettings.renderDistance.lowest;
+            if (renderDistance == GameSettings.RENDER_DISTANCE.highest && !shift) {
+                nextRenderDistance = GameSettings.RENDER_DISTANCE.lowest;
             }
-            if (renderDistance == this.gameSettings.renderDistance.lowest && shift) {
-                nextRenderDistance = this.gameSettings.renderDistance.highest;
+            if (renderDistance == GameSettings.RENDER_DISTANCE.lowest && shift) {
+                nextRenderDistance = GameSettings.RENDER_DISTANCE.highest;
             }
 
-            this.gameSettings.renderDistance.set(nextRenderDistance);
-            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.renderDistance);
+            GameSettings.RENDER_DISTANCE.set(nextRenderDistance);
+            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.RENDER_DISTANCE);
             return true;
         }
 
         // Toggle gamma
-        if (this.gameSettings.keyToggleGamma.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_TOGGLE_GAMMA.isPressEvent(currentInputDevice)) {
             int currentGammaStep = 2;
-            if (this.gameSettings.gamma.value < 0.125f) {
+            if (GameSettings.GAMMA.value < 0.125f) {
                 currentGammaStep = 0;
-            } else if (this.gameSettings.gamma.value < 0.375f) {
+            } else if (GameSettings.GAMMA.value < 0.375f) {
                 currentGammaStep = 1;
-            } else if (this.gameSettings.gamma.value > 0.875f) {
+            } else if (GameSettings.GAMMA.value > 0.875f) {
                 currentGammaStep = 4;
-            } else if (this.gameSettings.gamma.value > 0.625f) {
+            } else if (GameSettings.GAMMA.value > 0.625f) {
                 currentGammaStep = 3;
             }
             int newGammaStep = ((currentGammaStep + (shift ? -1 : 1)) + 5) % 5;
-            this.gameSettings.gamma.value = newGammaStep * 0.25f;
-            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(this.gameSettings.gamma);
+            GameSettings.GAMMA.value = newGammaStep * 0.25f;
+            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.GAMMA);
             return true;
         }
 
         // Hotbar left
-        if (this.gameSettings.keyHotBarLeft.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_HOT_BAR_LEFT.isPressEvent(currentInputDevice)) {
             this.thePlayer.inventory.changeCurrentSlot(1);
             return true;
         }
 
         // Hotbar right
-        if (this.gameSettings.keyHotBarRight.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_HOT_BAR_RIGHT.isPressEvent(currentInputDevice)) {
             this.thePlayer.inventory.changeCurrentSlot(-1);
             return true;
         }
 
         // Hotbar slots
         KeyBinding[] hotbarSlots = new KeyBinding[]{
-            this.gameSettings.keyHotBarSlot1,
-            this.gameSettings.keyHotBarSlot2,
-            this.gameSettings.keyHotBarSlot3,
-            this.gameSettings.keyHotBarSlot4,
-            this.gameSettings.keyHotBarSlot5,
-            this.gameSettings.keyHotBarSlot6,
-            this.gameSettings.keyHotBarSlot7,
-            this.gameSettings.keyHotBarSlot8,
-            this.gameSettings.keyHotBarSlot9
+            GameSettings.KEY_HOT_BAR_SLOT_1,
+            GameSettings.KEY_HOT_BAR_SLOT_2,
+            GameSettings.KEY_HOT_BAR_SLOT_3,
+            GameSettings.KEY_HOT_BAR_SLOT_4,
+            GameSettings.KEY_HOT_BAR_SLOT_5,
+            GameSettings.KEY_HOT_BAR_SLOT_6,
+            GameSettings.KEY_HOT_BAR_SLOT_7,
+            GameSettings.KEY_HOT_BAR_SLOT_8,
+            GameSettings.KEY_HOT_BAR_SLOT_9
         };
         for (int i = 0; i < hotbarSlots.length; i++) {
             if (hotbarSlots[i].isPressEvent(currentInputDevice)) {
